(*
 * Copyright (c) 2009-2010, Andrew Appel, Robert Dockins and Aquinas Hobor.
 *
 *)

Require Import base.
Require Import sepalg.
Require Import sepalg_generators.
Require Import sepalg_functors.
Require Import knot.
Require Import knot_sa.
Require Import knot_prop.

Module Trivial_TyFunctorSaProp (TF':TY_FUNCTOR_PROP) <: TY_FUNCTOR_SA_PROP.
  Module TF:=TF'.
  Import TF.
 
  Definition F_sa A (H:sepalg A) : sepalg (F A) := sa_equiv (F A).
  Implicit Arguments F_sa.

  Lemma fmap_hom : forall A B sa1 sa2 (f:A->B),
    @join_hom _ sa1 _ sa2 f ->
    @join_hom _ (F_sa sa1) _ (F_sa sa2) (fmap f).
  Proof.
    unfold join_hom; intuition; auto.
    simpl in H0; destruct H0; subst.
    compute; auto.
  Qed.

  Lemma F_preserves_unmaps : preserves_unmaps F F_sa fmap.
  Proof.
    constructor; intros.
    hnf; intros.
    simpl in H; destruct H; subst.
    exists z; exists z; simpl; intuition.
    split; auto.
    hnf; intros.
    simpl in H; destruct H; subst.
    exists x; exists x; simpl; intuition.
    split; auto.
  Qed.

  Lemma F_identities : forall A B (saA:sepalg A) (saB:sepalg B) (f:A->B) x,
    @identity _ (F_sa saB) (fmap f x) -> 
    @identity _ (F_sa saA) x.
  Proof.
    intros.
    rewrite identity_unit_equiv.
    hnf; split; auto.
  Qed.
End Trivial_TyFunctorSaProp.
